
//  Kaanna.cs (c) 2005 Kari Laitinen

//  http://www.naturalprogramming.com

//  2005-02-13  Tiedosto luotu.
//  2005-02-13  Viimeisin muutos.

using System ;
using System.Collections ;

class  KaksikielinenKaannos
{
   protected string ensimmainen_sana ;
   protected string toinen_sana ;

   public KaksikielinenKaannos() {}

   public KaksikielinenKaannos( string  annettu_ensimmainen_sana,
                                string  annettu_toinen_sana )
   {
      ensimmainen_sana  =  annettu_ensimmainen_sana ;
      toinen_sana       =  annettu_toinen_sana ;
   }

   public virtual bool kaanna( string annettu_sana )
   {
      bool  kaantaminen_onnistui  =  false ;

      if ( annettu_sana.Equals( ensimmainen_sana ) )
      {
         Console.Write( "\n \"" + annettu_sana + "\" kaantyy \""
                       + toinen_sana  + "\"" ) ;

         kaantaminen_onnistui  =  true ;
      }

      if ( annettu_sana.Equals( toinen_sana ) )
      {
         Console.Write( "\n \"" + annettu_sana + "\" kaantyy \""
                       + ensimmainen_sana  +  "\"" ) ;

         kaantaminen_onnistui  =  true ;
      }

      return  kaantaminen_onnistui ;
   }
}


class  KolmikielinenKaannos  :  KaksikielinenKaannos
{
   protected string kolmas_sana ;

   public KolmikielinenKaannos( string annettu_ensimmainen_sana,
                                string annettu_toinen_sana,
                                string annettu_kolmas_sana )
   {
      ensimmainen_sana  =  annettu_ensimmainen_sana ;
      toinen_sana       =  annettu_toinen_sana ;
      kolmas_sana       =  annettu_kolmas_sana ;
   }

   public override bool kaanna( string annettu_sana )
   {
      bool  kaantaminen_onnistui  =  false ;

      if ( annettu_sana.Equals( ensimmainen_sana ) )
      {
         Console.Write( "\n \"" + annettu_sana + "\" kaantyy \""
                   + toinen_sana  + "\" ja \"" + kolmas_sana + "\"" ) ;

         kaantaminen_onnistui  =  true ;
      }

      if ( annettu_sana.Equals( toinen_sana ) )
      {
         Console.Write( "\n \"" + annettu_sana + "\" kaantyy \""
                   + ensimmainen_sana  + "\" ja \"" + kolmas_sana  + "\"" ) ;

         kaantaminen_onnistui  =  true ;
      }

      if ( annettu_sana.Equals( kolmas_sana ) )
      {
         Console.Write( "\n \"" + annettu_sana + "\" kaantyy \""
                   + ensimmainen_sana  + "\" ja \"" + toinen_sana  + "\"" ) ;

         kaantaminen_onnistui  =  true ;
      }

      return  kaantaminen_onnistui ;
   }
}

class Kaanna
{
   static void Main( string[]  komentoriviparametrit )
   {
      if ( komentoriviparametrit.Length  ==  1 )
      {
         ArrayList  kaannostaulukko  =  new  ArrayList() ;

         kaannostaulukko.Add(
             new KaksikielinenKaannos( "week", "viikko" ) ) ;
         kaannostaulukko.Add(
             new KolmikielinenKaannos( "street", "katu", "calle" ) ) ;
         kaannostaulukko.Add(
             new KaksikielinenKaannos( "eat", "syoda" ) ) ;
         kaannostaulukko.Add(
             new KolmikielinenKaannos( "woman", "nainen", "mujer" ) ) ;
         kaannostaulukko.Add(
             new KolmikielinenKaannos( "man", "mies", "hombre" ) ) ;
         kaannostaulukko.Add(
             new KaksikielinenKaannos( "sleep", "nukkua" ) ) ;

         int  kaannoksen_indeksi  =  0 ;

         while ( kaannoksen_indeksi  <  kaannostaulukko.Count )
         {
            (  ( KaksikielinenKaannos )
               kaannostaulukko[ kaannoksen_indeksi ] ).

                       kaanna( komentoriviparametrit[ 0 ] ) ;

            kaannoksen_indeksi  ++  ;
         }

         Console.Write( "\n" ) ;
      }
      else
      {
         Console.Write( "\n Anna sana komentorivilla.\n\n" ) ;
      }
   }
}



